<template>
  <el-dialog
    :title="!dataForm.id ? '新增' : '修改'"
    :visible.sync="visible"
    :before-close="cancel"
    width="55%"
    v-dialogDrag>
    <!--立案审批表-->
    <el-form :model="dataForm" :rules="dataRules" ref="dataForm" label-width="140px"
             :disabled="dataForm.registerState == '1'">
      <el-row>
        <el-col :span="12">
          <el-form-item label="文件号">
            <el-input v-model="dataForm.referenceNumber"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="案件来源" prop="sourceType">
            <el-select v-model="dataForm.sourceType" placeholder="请选择案件来源">
              <el-option
                v-for="item in caseSourceList"
                :key="item.value"
                :label="item.label"
                :value="item.value">
              </el-option>
            </el-select>
          </el-form-item>
        </el-col>
      </el-row>

      <el-form-item label="案由" prop="casePoint">
        <el-input v-model="dataForm.casePoint"></el-input>
      </el-form-item>
      <el-row>
        <el-col :span="12">
          <el-form-item label="当事人姓名" prop="litigant">
            <el-input v-model="dataForm.litigant"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="法定代表人" prop="legalPerson">
            <el-input v-model="dataForm.legalPerson"></el-input>
          </el-form-item>
        </el-col>
      </el-row>

      <el-row>
        <el-col :span="12">
          <el-form-item label="当事人证件名称" prop="litigantCert">
            <el-select v-model="dataForm.litigantCert" placeholder="请选择证件名称">
              <el-option
                v-for="item in certList"
                :key="item.value"
                :label="item.label"
                :value="item.value">
              </el-option>
            </el-select>
            <!--            <dict dict="documentType" v-model="dataForm.litigantCert"
                              placeholder="请选择当事人证件类型" :disabled="dataForm.registerState == '1'"/>-->
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="当事人证件号码" prop="certNo">
            <el-input v-model="dataForm.certNo"></el-input>
          </el-form-item>
        </el-col>
      </el-row>
      <el-row>
        <el-col :span="12">
          <el-form-item label="住址" prop="address">
            <el-input v-model="dataForm.address"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="电话" prop="phone">
            <el-input v-model="dataForm.phone"></el-input>
          </el-form-item>
        </el-col>
      </el-row>

      <el-form-item label="案情及立案理由" prop="caseDetail">
        <el-input type="textarea" :row="2" v-model="dataForm.caseDetail"></el-input>
      </el-form-item>
      <el-row>
        <el-col :span="12">
          <el-form-item label="办案人员" prop="hanlderIds">
            <el-input v-model="dataForm.hanlderIds"></el-input>
<!--            <el-select v-model="dataForm.hanlderIds" clearable filterable multiple :multiple-limit="2"-->
<!--                       placeholder="请选择" style="width: 100%;" @change="setPersonname($event)">-->
<!--              <el-option-->
<!--                v-for="item in organPersons"-->
<!--                :key="item.id"-->
<!--                :label="item.nickname"-->
<!--                :value="item.id">-->
<!--                <span style="float: left">{{ item.nickname }}</span>-->
<!--                <span style="float: right; color: #8492a6; font-size: 13px">执法证号：{{ item.lawCert }}</span>-->
<!--              </el-option>-->
<!--            </el-select>-->
          </el-form-item>
        </el-col>
<!--        <el-col :span="12">-->
<!--          <el-form-item label="是否立案" prop="isCase">-->
<!--            &lt;!&ndash;              <dict dict="whether" :disabled="dataForm.registerState == '1'" v-model="dataForm.isCase"-->
<!--                                placeholder="请选择是否立案"/>&ndash;&gt;-->
<!--            <el-select v-model="dataForm.isCase" placeholder="请选择是否立案">-->
<!--              <el-option-->
<!--                v-for="item in whetherList"-->
<!--                :key="item.value"-->
<!--                :label="item.label"-->
<!--                :value="item.value">-->
<!--              </el-option>-->
<!--            </el-select>-->
<!--          </el-form-item>-->
<!--        </el-col>-->
      </el-row>
<!--      <public-opinion ref="publicOpinion" :registerState="dataForm.registerState"></public-opinion>-->
<!--      <WordView ref="wordInfo" :isShowYulan="showView" @cancel="cancelWord"></WordView>-->
    </el-form>
    <div slot="footer" class="dialog-footer" style="text-align: center;">
      <el-button @click="cancel">取 消</el-button>
      <el-button v-if="dataForm.registerState != '1'" :loading="submitLoading" type="primary"
                 @click="dataFormSubmit('0')">保存
      </el-button>
      <el-button v-if="dataForm.registerState != '1'" :loading="submitLoading" type="warning"
                 @click="dataFormSubmit('1')">定稿
      </el-button>
      <el-button type="primary" plain @click="viewVord(dataForm)">预览</el-button>
      <el-button type="success" plain @click="downloadWord(dataForm)">下载</el-button>
      <WordView ref="wordInfo" :isShowYulan="showView" @cancel="cancelWord"></WordView>
    </div>
  </el-dialog>
</template>

<script>
import {getObj, saveObj} from '@/api/News/fileCase'
import moment from 'moment'
import WordView from '@/views/News/word-view/index'
import {remote} from "@/api/admin/dict";
// import publicOpinion from "@/views/News/publicOpinion"

export default {
  name: "case-form",
  components: {
    WordView
  },
  data() {
    return {
      visible: false,
      submitLoading: false,
      showView: false,
      xuncha: true,
      tousu: false,
      yisong: false,
      qita: false,
      persons: [],
      caseSourceList: [],
      //  是否确定数据
      whetherList: [],
      certList:[],
      dataForm: {
        referenceNumber: '',
        sourceType: '',
        casePoint: '',
        litigant: '',
        litigantCert: '',
        certNo: '',
        address: '',
        phone: '',
        legalPerson: '',
        caseDetail: '',
        hanlders: '',
        registerState: '',
        hanlderIds: ''
      },
      dataRules: {}
    };
  },
  created() {

  },
  methods: {
    // 接参数
    init(id) {
      //查询用户
      console.log(id, 'id--==')
      // this.getUsers('');
      this.dataForm.id = id || '';
      this.visible = true;

      this.$nextTick(() => {
        this.getDataType();
      if (this.dataForm.id != '') {
        getObj(this.dataForm.id).then(response => {
          // 转换null为""
          /*let v = response.result;
          for (let attr in v) {
            if (v[attr] == null) {
              v[attr] = "";
            }
          }*/
          console.log(response, 'v--=')
          this.dataForm = response.data.data;

          // if (response.data.data.personId != "") {
          //   this.dataForm.personId = response.data.data.personId.split(',');
          // }

        })
      }
      });
    },
    //获取来源
    getDataType() {
      remote('caseSource_Type').then(res => {
        this.caseSourceList = res.data.data
      }),
      remote('document_type').then(res => {
        this.certList = res.data.data
      }),
      remote('whether').then(res => {
         this.whetherList = res.data.data
      })
    },
    /*getUsers(username) {
      findUsers(username).then(response => {
        if (response.success) {
          this.persons = response.result;
        }
      })
    },*/
    setPersonname(val) {
      let names = "";
      for (let i in this.persons) {
        if (val.toString().indexOf(this.persons[i].id) > -1) {
          names += this.persons[i].nickname + ",";
        }
      }
      if (names != "") {
        this.dataForm.handlePerson = names.substring(0, names.length - 1);
      }
    },
    //重置
    reset() {
      this.dataForm = {
        referenceNumber: '',
        sourceType: '',
        casePoint: '',
        litigant: '',
        litigantCert: '',
        certNo: '',
        address: '',
        phone: '',
        legalPerson: '',
        caseDetail: '',
        hanlders: '',
        registerState: '',
        hanlderIds: ''
      }
    },
    // 关闭弹框
    cancel() {
      this.visible = false;
      this.$emit("cancel");
      this.reset();
    },
    dataFormSubmit(type) {
      this.$refs['dataForm'].validate((valid) => {
        if (valid) {
          let obj = this;
          if ("1" == type) {
            this.$confirm('保存为定稿将不能修改，是否继续？', '提示', {
              confirmButtonText: '是',
              cancelButtonText: '否',
              type: 'warning'
            }).then(function () {
              obj.submitLoading = true;
              obj.dataForm.registerState = type;
              saveObj(obj.dataForm).then((res) => {
                  obj.$message.success("操作成功");
                  obj.cancel();
                  obj.$emit('getDataList');
              })
            })
          } else {
            saveObj(this.dataForm).then((res) => {
              // this.submitLoading = false;
              // if (res.data) {
                this.$message.success("操作成功");
                this.cancel();
                this.$emit('getDataList');
              // }
            })
          }

        }
      })

    },
    //  来源类别与其他来源绑定
    changeType(value) {
      if ('巡查发现' == value) {
        this.xuncha = true;
        this.yisong = false;
        this.tousu = false;
        this.qita = false;
        this.dataForm.fieldFive = '';
        this.dataForm.fieldSix = '';
        this.dataForm.fieldSeven = '';
        this.dataForm.otherSource = '';
      } else if ('投诉、举报' == value) {
        this.xuncha = false;
        this.yisong = false;
        this.tousu = true;
        this.qita = false;
      } else if (value == '其他部门移送' || value == '上级交办') {
        this.xuncha = false;
        this.yisong = true;
        this.tousu = false;
        this.qita = false;
        this.dataForm.fieldThree = '';
        this.dataForm.fieldFour = '';
        this.dataForm.fieldSeven = '';
        this.dataForm.otherSource = '';
      } else {
        this.qita = true;
        this.xuncha = false;
        this.yisong = false;
        this.tousu = false;
        this.dataForm.fieldOne = '';
        this.dataForm.fieldTwo = '';
        this.dataForm.fieldThree = '';
        this.dataForm.fieldFour = '';
        this.dataForm.fieldFive = '';
        this.dataForm.fieldSix = '';
        this.dataForm.fieldSeven = '';
      }

    },
    //下载word
    downloadWord(obj) {
      let wordData = this.transferData(obj);
      WordView.methods.exportDoc(wordData, "/wordes/lasp.docx", "立案审批表.docx");
    },
    //预览word
    viewVord(obj) {
      //↓↓↓↓↓↓以下部分根据具体业务修改↓↓↓↓↓↓
      //时间格式转换
      let wordData = this.transferData(obj);
      //↑↑↑↑↑↑以上部分根据具体业务修改↑↑↑↑↑↑
      this.showView = true;
      this.$nextTick(() => {
        this.$refs.wordInfo.init(wordData, "/wordes/lasp.docx", "立案审批表.docx");
      })
    },
    cancelWord() {
      this.showView = false;
    },
    transferData(obj) {
      let str = JSON.stringify(obj);
      let data = JSON.parse(str);
      //时间
      if (data.registerTime != '' && data.registerTime != null) {
        data.registerTime = moment(data.registerTime).format('YYYY年MM月DD日 HH时mm分');
      }
      if (data.signTime != '' && data.signTime != null) {
        data.signTime = moment(data.signTime).format('YYYY年MM月DD日');
      } else {
        data.signTime = '  年  月  日'
      }
      if (data.opinionTime != '' && data.opinionTime != null) {
        data.opinionTime = moment(data.opinionTime).format('YYYY年MM月DD日');
      } else {
        data.opinionTime = '  年  月  日'
      }
      if (data.otherSource == '' || data.otherSource == null) {
        data.otherSource = '      ';
      }

      //根据案件来源变
      if (data.sourceType === '巡查发现') {
        data.personOne = data.fieldOne;
        data.unitOne = data.fieldTwo;
        data.personTwo = data.fieldThree;
        data.unitTwo = data.fieldFour;
        data.unitName = '';
        data.unitLegal = '';
        data.reportPerson = '';
        data.idCard = '';
        data.repPhone = '';
        data.repLink = '';
        data.repAddress = '';
        data.sendDept = '';
        data.sendPerson = '';
        data.sendAdd = '';
        data.sendPhone = '';
        data.xct = true;
        data.jbf = true;
        data.ysf = true;
        data.sjf = true;
        data.qtf = true;
      } else if (data.sourceType == '投诉、举报') {
        data.unitName = data.fieldOne;
        data.unitLegal = data.fieldTwo;
        data.reportPerson = data.fieldFour;
        data.idCard = data.fieldFive;
        data.repPhone = data.fieldSix;
        data.repLink = data.fieldSeven;
        data.repAddress = '';
        data.sendDept = '';
        data.sendPerson = '';
        data.sendAdd = '';
        data.sendPhone = '';
        data.personOne = '';
        data.unitOne = '';
        data.personTwo = '';
        data.unitTwo = '';
        data.jbt = true;
        data.xcf = true;
        data.ysf = true;
        data.sjf = true;
        data.qtf = true;
      } else if (data.sourceType == '其他部门移送' || data.sourceType == '上级交办') {
        data.unitName = '';
        data.unitLegal = '';
        data.reportPerson = '';
        data.idCard = '';
        data.repPhone = '';
        data.repLink = '';
        data.repAddress = '';
        data.sendDept = data.fieldOne;
        data.sendPerson = data.fieldTwo;
        data.sendAdd = data.fieldSix;
        data.sendPhone = data.fieldFive;
        data.personOne = '';
        data.unitOne = '';
        data.personTwo = '';
        data.unitTwo = '';
        if (data.sourceType == '其他部门移送') {
          data.yst = true;
          data.xcf = true;
          data.jbf = true;
          data.sjf = true;
          data.qtf = true;
        } else {
          data.sjt = true;
          data.xcf = true;
          data.jbf = true;
          data.ysf = true;
          data.qtf = true;
        }
      } else {
        data.unitName = '';
        data.unitLegal = '';
        data.reportPerson = '';
        data.idCard = '';
        data.repPhone = '';
        data.repLink = '';
        data.repAddress = '';
        data.sendDept = '';
        data.sendPerson = '';
        data.sendAdd = '';
        data.sendPhone = '';
        data.personOne = '';
        data.unitOne = '';
        data.personTwo = '';
        data.unitTwo = '';
        data.qtt = true;
        data.xcf = true;
        data.jbf = true;
        data.ysf = true;
        data.sjf = true;
      }
      return data;
    }
  }
}
</script>

<style scoped>
h2 {
  text-align: center;
  margin: 10px 0 10px -60px;
}

h3 {
  margin: 10px 50px;
}
</style>
